#*******************************************************
#                                                      *
#           NutStats 1.3 by M4rc3L-XCN                 *
#           Require: Eventscripts 2.0+                 *
#                                                      *
#       This is a ingame statsviewer for HLStatsX      *
# The Script is running for HLStatsX Community Edition *
# http://addons.eventscripts.com/addons/view/NutStats  *   
#*******************************************************
import es, re, sys, usermsg, playerlib, string, psyco, gamethread, esamlib, saytextlib, popuplib, string
psyco.full()
NutStats = "1.3"
global nutstats_array, nutstats_update
nutstats_update = "no" 
nutstats_array = { "version" : "0" , "webpage" : "0"}
def load():
  ifxcnvar = es.exists('variable','M4rc3L-XCN')
  if ifxcnvar != 1:
    M4rc3L = "NutStats"
  else:
    marcel = str(es.ServerVar("M4rc3L-XCN"))
    marstat = marcel.split(",")
    if not "NutStats" in marstat:
      M4rc3L = "%s,%s" % (marcel,"NutStats")
    else:
      M4rc3L = marcel
  es.set("M4rc3L-XCN",M4rc3L)
  es.set("NutStats",NutStats)
  es.makepublic("NutStats")
  es.makepublic("M4rc3L-XCN")
  if not es.exists('command','nut_psay'):
    es.regcmd("nut_psay","nut_stats/msg_p", "")
  if not es.exists('command','nut_csay'):
    es.regcmd("nut_csay","nut_stats/msg_c", "")
  if not es.exists('command','nut_msay'):
    es.regcmd("nut_msay","nut_stats/msg_m", "")
  # register hlxce commands for popup
  if not es.exists('command','hlxce_version'):
    es.regcmd("hlxce_version", "nut_stats/cmd_hlxce_version", "")
  if not es.exists('command','hlxce_webpage'):
    es.regcmd("hlxce_webpage", "nut_stats/cmd_hlxce_webpage", "")   

  es.msg("#multi", "#green[NutStats]#default loaded!")
  es.addons.registerSayFilter(sayCommands)
  gamethread.delayed(7,check_update_available)

def es_map_start(ev):
  gamethread.delayed(7,check_update_available)

def unload():
  es.addons.unregisterSayFilter(sayCommands)
  if popuplib.exists('nutstatsmenu'):
    popuplib.delete('nutstatsmenu')
  es.msg("#multi", "#green[NutStats]#default unloaded!")

# check for updates
def check_update_available():
  global NutStats
  update_available = esamlib.getAddon("NutStats")
  new_version = update_available.currentversion
  if not new_version == NutStats:
    es.msg("#multi", "#green[NutStats]#default Update is available!!! New version is: %s" %new_version)
    es.log("[NutStats] Update is available!!! New version is: %s" %new_version)
    global nutstats_update
    nutstats_update = "yes (%s)" %new_version

def cmd_hlxce_version():
  global nutstats_array
  nutstats_array["version"]=es.getargs()

def cmd_hlxce_webpage():
  global nutstats_array
  nutstats_array["webpage"]=es.getargs() 

# statsinfo command
def nutstats_info(user):
  global nutstats_array, nutstats_update
  if nutstats_array["version"] != "0":
    nsa_version = nutstats_array["version"].strip('"')
  else:
    nsa_version = "unknown"
  if nutstats_array["webpage"] != "0":
    nsa_webpage = nutstats_array["webpage"].strip('"')
  else:
    nsa_webpage = "unknown"
  statsinfomsg = "NutStats Information\n \n->1.NutStats:\n   version: %s\n   update: %s\n \n->2.HLStatsX:\n   version: %s\n   webpage: %s\n \n say 'statspage' to see the Webpage" %(NutStats,nutstats_update,nsa_version,nsa_webpage)
  es.menu(8, user, statsinfomsg)
# statspage in browser
def nutstats_statspage(user):
  global nutstats_array
  if nutstats_array["webpage"] != "0":
    nsa_webpage = nutstats_array["webpage"].strip('"')
    usermsg.motd(user, 2, "HLStatsX Webpage", nsa_webpage) 
  else:
    es.tell(user,"#multi", "#green[NutStats]#default Webpage not tracked by the server")

# client say command filter 
def sayCommands(userid,text,teamonly):
  text = text.strip('"')
  if text.lower() == "place":
    send_player_eintrag(userid,"say","/place")
    return (False, False, False)
  if text.lower() == "next":
    send_player_eintrag(userid,"say","/next")
    return (False, False, False)
  if text.lower() == "kpd":
    send_player_eintrag(userid,"say","/kpd")
    return (False, False, False)
  if text.lower() == "rank":
    send_player_eintrag(userid,"say","/rank")
    return (False, False, False)
  if text.lower() == "session":
    send_player_eintrag(userid,"say","/session")
    return (False, False, False)
  if text.lower() == "statsinfo":
    nutstats_info(userid)
    return (False, False, False)
  if text.lower() == "statspage":
    nutstats_statspage(userid)
    return (False, False, False)
  else:
    return (userid, text, teamonly)
  return (userid, text, teamonly)

# send a hide message to server log
def get_player_eintrag(user):
  spielername = es.getplayername(user)
  team = es.getplayerteam(user)
  steamid = es.getplayersteamid(user)
  teamnames = { 0: "Unassigned", 1: "Spectator", 2: "TERRORIST", 3 : "CT" } 
  lognachricht = '"%s<%s><%s><%s>"' %(spielername,user,steamid,teamnames[team])
  return lognachricht

def send_player_eintrag(userid,typ,mem):
  if typ == "say":
    logline='%s say "%s"' %(get_player_eintrag(userid),mem)
  es.server.queuecmd("es_xlogq %s" %logline)

# nut_msay Block - Popup
def msg_m():
  Message_M = es.getargv(3)
  Message_MT = Message_M.strip("\n").split("\\n")
  nutstatsmenu = popuplib.create('nutstatsmenu')
  for lines in Message_MT:
    nutstatsmenu.addline('%s' %lines)
  nutstatsmenu.send(int(es.getargv(2)))
  
  

# nut_csay Block - hudhint
def msg_c():
      for playid in es.getUseridList():
        cmessage = es.getargs().strip('"')
        usermsg.hudhint(playid,cmessage)

# nut_psay Block - say commands
def msg_p():
  Pmessage = es.getargs()
  Pmessagestrip = Pmessage.strip('"')
  if re.search("is on rank", Pmessage):
    text=re.split('\x04',Pmessage)
    text=re.split(' is on rank ',text[1])
    text2=re.split(' of ',text[1])
    text3=re.split(' with ',text2[1])
    ns_playerpunkte=text3[1].replace(" points!","").strip('"')
    ns_playername = text[0]
    ns_playerrank = text2[0]
    ns_totalrank = text3[0]
    retrieve_uid = es.getuserid(ns_playername)
    allespieler = playerlib.getPlayerList('#human')
    for play in allespieler:
      playerlang = play.attributes['language']
      if playerlang == "german":
        saytextlib.saytext2(play.userid,get_player_teamindex(retrieve_uid),'#green[NutStats] #team%s#default\'s Rank ist %s von %s mit %s Punkten!' % (ns_playername,ns_playerrank,ns_totalrank,ns_playerpunkte))
        #es.tell(play.userid,"#multi", "#lightgreen[NutStats]#green %s#default\'s Rank ist %s von %s mit %s Punkten!" % (ns_playername,ns_playerrank,ns_totalrank,ns_playerpunkte))
      else:
        saytextlib.saytext2(play.userid,get_player_teamindex(retrieve_uid),'#green[NutStats] #team%s#default\'s rank is %s of %s with %s points!' % (ns_playername,ns_playerrank,ns_totalrank,ns_playerpunkte))
        #es.tell(play.userid,"#multi", "#lightgreen[NutStats]#green %s#default\'s rank is %s of %s with %s points!" % (ns_playername,ns_playerrank,ns_totalrank,ns_playerpunkte))
  if re.search("Need at least",Pmessagestrip):
    text=re.split('\(',Pmessagestrip)
    players=re.split('/',text[1])
    maxplayers=re.split('\)',players[1])
    if int(players[0]) < int(maxplayers[0]):
      allespieler = playerlib.getPlayerList('#human')
      for play in allespieler:
        playerlang = play.attributes['language']
        if playerlang == "german":
          es.tell(play.userid,"#multi", "#green[NutStats]#lightgreen Deaktiviert!#default %s von %s Spielern ben\xc3\xb6tigt!" % (maxplayers[0],players[0]))
        else:
          es.tell(play.userid,"#multi", "#green[NutStats]#lightgreen Disabled!#default %s of %s Players required!" % (maxplayers[0],players[0]))

# get player teamindex for saytextlib team
def get_player_teamindex(uid):
  pltid = playerlib.getPlayer(uid)
  return pltid.attributes['index']